IFY = {};

function IFY:loadMap(name)
	IFY.settingsDir = getUserProfileAppPath().. "modSettings/IFY/";
	IFY:ApplySettings();

end;


function IFY:mouseEvent(posX, posY, isDown, isUp, button)
end;

function IFY:keyEvent(unicode, sym, modifier, isDown)
end;

function IFY:update(dt)
end;

function IFY:draw(dt)
end;

function IFY:ApplySettings()
    local fruitTypes = {
        "WHEAT",
        "BARLEY",
        "CANOLA",
        "OAT",
        "MAIZE",
        "SUNFLOWER",
        "SOYBEAN",
        "POTATO",
        "RICE",
        "RICELONGGRAIN",
        "SUGARBEET",
        "OILSEEDRADISH",
        "POPLAR",
        "SUGARCANE",
        "GRASS",
        "DRYGRASS",
        "MILLET",
        "RYE",
        "CARROT",
        "ONION",
        "LETTUCE",
        "CABBAGE",
        "SPELT",
        "POPPY",
        "HOPS",
        "TOBACCO",
        "SORGHUM",
        "GRAPE",
        "OLIVE",
        "BEETROOT",
        "GREENBEAN",
        "PEA",
        "PARSNIP"
    }

	local sprayTypes = {
		"FERTILIZER", 
		"LIQUIDFERTILIZER",
		"MANURE",
		"LIQUIDMANURE",
		"DIGESTATE",
		"LIME",
		"HERBICIDE"
	};

	local file = IFY.settingsDir.. "IFYSettings.xml";
	local xmlContent = loadXMLFile("IFYSettings_XML", file, "IFYSettings");

	-- apply fruit types 
	local pos = 0;
	local rootPath = "IFYSettings.fruitTypes";
	local groupNameTag = "";

	for _, frType in pairs(fruitTypes) do
		groupNameTag = string.format("%s.fruitType(%d)", rootPath, pos);		
		
		local fruitXmlName = Utils.getNoNil(getXMLString(xmlContent, groupNameTag .. "#name"), "");
		local fruitXmlSeedUsage = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#seedUsagePerSqm"), -1);
		local fruitXmlLiters = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#literPerSqm"), -1);

		if fruitXmlName ~= "" and fruitXmlSeedUsage ~= -1 and fruitXmlLiters ~= -1 then 
			local ft = g_fruitTypeManager:getFruitTypeByName(fruitXmlName);

			if ft ~= nil then			
				ft.seedUsagePerSqm = fruitXmlSeedUsage;
				ft.literPerSqm = fruitXmlLiters;

				print(string.format("Apply new values for FruitType name - %s, seedUsagePerSqm - %s, literPerSqm - %s", fruitXmlName, fruitXmlSeedUsage, fruitXmlLiters));				

			end;
		end;

		pos = pos + 1;		

	end;

	-- apply spray types
	pos = 0;
	rootPath = "IFYSettings.sprayTypes";	

	for _, spType in pairs(sprayTypes) do
		groupNameTag = string.format("%s.sprayType(%d)", rootPath, pos);		
		
		local sprayXmlName = Utils.getNoNil(getXMLString(xmlContent, groupNameTag .. "#name"), "");
		local sprayXmlLitersUsage = Utils.getNoNil(getXMLFloat(xmlContent, groupNameTag .. "#litersPerSecond"), -1);		

		if sprayXmlName ~= "" and sprayXmlLitersUsage ~= -1 then 
			local sp = g_sprayTypeManager:getSprayTypeByName(sprayXmlName);

			if sp ~= nil then			
				sp.litersPerSecond = sprayXmlLitersUsage;				

				print(string.format("Apply new values for SprayType name - %s, litersPerSecond - %s", sprayXmlName, sprayXmlLitersUsage));				

			end;
		end;

		pos = pos + 1;		

	end;	

end;

function IFY:BuildFruitTypeXMLNode(xmlContent, groupNameTag, cropName, seedUsage, litersOutput, defaultSeedUsage, defaultLitersOutput)
	setXMLString(xmlContent, groupNameTag .. "#name", cropName);
	setXMLFloat(xmlContent,  groupNameTag .. "#seedUsagePerSqm", seedUsage);
	setXMLFloat(xmlContent,  groupNameTag .. "#literPerSqm", litersOutput);	
	setXMLFloat(xmlContent,  groupNameTag .. "#defaultSeedUsagePerSqm", defaultSeedUsage);
	setXMLFloat(xmlContent,  groupNameTag .. "#defaultLiterPerSqm", defaultLitersOutput);	
end;

function IFY:BuildSprayTypeXMLNode(xmlContent, groupNameTag, sprayName, litersUsage, defaultLitersUsage)
	setXMLString(xmlContent, groupNameTag .. "#name", sprayName);
	setXMLFloat(xmlContent,  groupNameTag .. "#litersPerSecond", litersUsage);
	setXMLFloat(xmlContent,  groupNameTag .. "#defaultLitersPerSecond", defaultLitersUsage);	
end;

addModEventListener(IFY);